VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.2#0"; "comctl32.ocx"
Begin VB.Form frmMain 
   Caption         =   "Progress bar in status panel demo"
   ClientHeight    =   1035
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6945
   LinkTopic       =   "Form1"
   ScaleHeight     =   1035
   ScaleWidth      =   6945
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdProcess 
      Caption         =   "Do Some Work"
      Height          =   435
      Left            =   120
      TabIndex        =   2
      Top             =   180
      Width           =   1995
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   2400
      Top             =   120
   End
   Begin VB.PictureBox picProgress 
      Height          =   255
      Left            =   3060
      ScaleHeight     =   195
      ScaleWidth      =   1515
      TabIndex        =   1
      Top             =   240
      Width           =   1575
   End
   Begin ComctlLib.StatusBar sbStatusBar 
      Align           =   2  'Align Bottom
      Height          =   285
      Left            =   0
      TabIndex        =   0
      Top             =   750
      Width           =   6945
      _ExtentX        =   12250
      _ExtentY        =   503
      SimpleText      =   ""
      _Version        =   327682
      BeginProperty Panels {0713E89E-850A-101B-AFC0-4210102A8DA7} 
         NumPanels       =   4
         BeginProperty Panel1 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            AutoSize        =   1
            Object.Width           =   8149
            Key             =   "pnlStatus"
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel2 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Object.Visible         =   0   'False
            Object.Width           =   3528
            MinWidth        =   3528
            Key             =   "pnlProgress"
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel3 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Style           =   6
            Alignment       =   1
            AutoSize        =   2
            Object.Width           =   1773
            MinWidth        =   1764
            TextSave        =   "12/15/97"
            Key             =   "pnlDate"
            Object.Tag             =   ""
         EndProperty
         BeginProperty Panel4 {0713E89F-850A-101B-AFC0-4210102A8DA7} 
            Style           =   5
            Alignment       =   1
            AutoSize        =   2
            Object.Width           =   1773
            MinWidth        =   1764
            TextSave        =   "9:52 AM"
            Key             =   "pnlTime"
            Object.Tag             =   ""
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Progress As Long
Private m_ProgBar As CProgressBarEx
Private m_Status As String

' ***************************************************
'  Public Properties
' ***************************************************
Public Property Let Status(ByVal NewVal As String)
   Const StatKey = "pnlStatus"
   m_Status = NewVal
   sbStatusBar.Panels(StatKey).Text = m_Status
End Property

Public Property Get Status() As String
   Status = m_Status
End Property

Public Property Let Progress(ByVal NewVal As Long)
   Const ProgKey = "pnlProgress"

   If m_ProgBar Is Nothing Then
      Set m_ProgBar = New CProgressBarEx
      Set m_ProgBar.Client = picProgress
      Set m_ProgBar.Host = sbStatusBar
      m_ProgBar.PanelKey = ProgKey
      m_ProgBar.ResizeEx
   End If

   With sbStatusBar.Panels(ProgKey)
      If NewVal = 0 Then
         .Visible = False
      ElseIf NewVal > 0 And NewVal <= 100 Then
         If .Visible = False Then .Visible = True
      Else
         Exit Property
      End If
   End With
   
   m_Progress = NewVal
   m_ProgBar.Value = m_Progress
End Property

Public Property Get Progress() As Long
   Progress = m_Progress
End Property

' ***************************************************
'  Event Procedures
' ***************************************************
Private Sub cmdProcess_Click()
   Me.Status = "Working very, very hard!"
   Timer1.Enabled = True
End Sub

Private Sub Form_Load()
   Set Me.Icon = Nothing
End Sub

Private Sub Timer1_Timer()
   Static Percent As Long
   
   Percent = Percent + 1
   If Percent > 100 Then
      Timer1.Enabled = False
      Percent = 0
      Me.Status = ""
   End If
   Me.Progress = Percent
End Sub
